/*
 * TOAD -- A Simple and Powerful C++ GUI Toolkit for the X Window System
 * Copyright (C) 1996-99 by Mark-Andr Hopf
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 * MA  02111-1307,  USA
 */

#ifndef TPushButton
#define TPushButton TPushButton

#ifndef TButtonBase
#include <toad/buttonbase.hh>
#endif

class TPushButton: public TButtonBase
{
		int _id;
	public:
		TPushButton(TWindow *p, const string &t, int id=-1)
		:TButtonBase(p,t){_id = id;}
		
		int ID() { return _id; }

	protected:
		void paint();
		void mouseLDown(int,int,unsigned);
		void mouseLUp(int,int,unsigned);
		void mouseEnter(int,int,unsigned);
		void mouseLeave(int,int,unsigned);
		void keyDown(TKey,char*,unsigned);
};

#endif
